DAT programName  byte "CountDown120126g", 0
CON
{{
  modified from Demo_74HC595_MultiPWM_Menu100727d.spin
  Version D100806a set defaults for LEDs.  Modify
  communication protocol.
  Version 100910a add RS-485 communication.  11e works
  a little with Z100911c.  f disable RS-485 between
  transmissions.  24a Move all Nordic calls to one
  cog.  a receives RF okay.  Problem passing on
  wireless commands.  Wired (debug) commands work.
  24e works with F100924d.  b combine LightLeds with
  Clock method.  c combining objects not working yet.
  d with LEDs 21 and 22 on there is a lot of leakage
  to LEDs 4, 15, and 33.  e try adding Clock method to
  different cog.  e works okay.  Still leakage if more
  than one LED lit.  101011a use external header file.
  110127a move some of the arrays to DAT section to
  clean up the code a bit.
  110601a measure current
  3.3V only = 0.14A
  Change name to CountDown120125a.
  120125a change pins to work with RcAssist board.
  Remove unused portions of code.
  25e is working pretty well.
  0204a start adding ability to flash digits.
  0205a start adding clock and timer setting features.
  0206d I can kind of set time now.
  The minutes don't always display when I'm setting the time.
  06e when minutes or seconds are changed, the focus moves to
  hours.
  06g start adding real time clock support.
  
  To enter set time or timer mode invert Nunchuck, press and hold both
  buttons.  Bring Nunchuck right side up and then release both buttons.

  To change clock time.  Press and hold "C" button.
  Bring Nunchuck right side up and then release button.

  To change count down time.  Press and hold "Z" button.
  Bring Nunchuck right side up and then release button.

   
  12V from LiPo
 

  6 shift registers on external display
  3 on LED array
  1 high power on LED array (doesn't use PWM)

  cog use
  0 Main loop, RS-485 communication, listen to debug line.
  1 pcFullDuplexSerial4FC
  2 74HC595_MultiPWM
  3 74HC595_MultiPWM
  4 74HC595_MultiPWM
  5 Simple_74HC595
  6 MainLoop
  7 Clock
  8 lightLeds combined with Clock cog

  
  
}}
CON


  _clkmode = xtal1 + pll16x                             ' use crystal x 16
  _xinfreq = 5_000_000                                  ' 5 MHz cyrstal (sys clock = 80 MHz)

  ' Pin assignments
  _Radio0 = 0
  _Radio1 = 1
  _Radio2 = 2
  _Radio3 = 3
  _Radio4 = 4
  _Radio5 = 5
  _Radio6 = 6

  ' Set this to the pins you have connected to the 74HC595's

  _ShiftRegisterClockA = _Radio0 '16'21
  _ShiftRegisterLatchA = _Radio1 '17'22
  _ShiftRegisterDataA  = _Radio2 '18'23
  _ShiftRegisterClockB = _Radio3 '19'21
  _ShiftRegisterLatchB = _Radio4 '20'22
  _ShiftRegisterDataB  = _Radio5 '21'23

  ' Nordic pins
  _NordicCePin = 22             'trf24g data i/o select
  _NordicCsPin = 24             'trf24g configuration select
  _NordicReadyPin = 27           'trf24g data ready bit
  _NordicClockPin = 26           'trf24g clock
  _NordicDataPin = 25            'trf24g data i/o bit
    
  '_AllRows = %001111110000000000000000
 
  _InitialDuration = 8000

  Character0 = %11111100'00111111'        
  Character1 = %01100000'00000110'      
  Character2 = %11011010'01011011'       
  Character3 = %11110010'01001111'     
  Character4 = %01100110'01100110'      
  Character5 = %10110110'01101101'  
  Character6 = %10111110'01111101'     
  Character7 = %11100000'00000111'   
  Character8 = %11111110'01111111'    
  Character9 = %11100110'01100111'
  CharacterDP = %00000001'10000000

  ' com enumeration for ComError method
  #0, _ComZ, _ComNordic
   
  'Communication lines enumeration for pcFullDuplexSerial4FC object
  #0, _Debug

  'Digit groups enumeration for LED seven digit display
  #0, _SecondsPlace, _MinutesPlace, _HoursPlace  

  #0, _ClockModeCountdown, _EndOfCountdown, _Countdown, _PauseCountdown, _ReadyToCountdown, _ResetCountdown

  ' displayMode enumeration
  #0, _ClockDisplay, _Countdown0Display, _Timer0Display
  
  ' SetState enumeration
  #0, _NormalState, _SettableState

  'Settings enumeration 
  #0, _NoSetting, _UpRightSetting, _UpsideDownSetting, _CAndZInitSetting, {
    } _CAndZTiggeredSetting, _CAndZLockedSetting, _CInitSetting, _CTiggeredSetting, {
    } _ZInitSetting, _ZTiggeredSetting, _TimeSetting, _CountdownSetting
   
  ' noButton enumeration
  #0, _PressedSinceUpButton, _UpNoButton, _UpToDownNoButton

  ' bothButtons enumeration
  #0, _ReleasedSinceDownBoth, _DownBoth, _DownHeldBoth, _DownToUpBoth, _FinalReleaseBoth

  
  _FlashOff = -1
  _I2cClock = 28
  _I2cData = 29
  _SingleButtonCountThreshold = 2

  'Nunchuck Constants

  _JxFarLeft = 26
  _JxFarRight = 224
  _JxLeftCenterEdge = 125
  _JxRightCenterEdge = 135
  _JyFarForward = 223
  _JyFarBackward = 29
  _JyForwardCenterEdge = 135
  _JyBackwardCenterEdge = 128
  _ChangeDigitThreshold = 30
  _OtherAxisLimit = 10
  _SettingDivider = 10

  _AxRawCenter = 492
  _AxJitter = 5
  _AyRawCenter = 500
  _AyJitter = 5
  _AzRawCenter = 656
  _AzBuffer = 3
  
  _UpHighThreshold = 710
  _UpLowThreshold = 640
  _DownHighThreshold = 310
  _DownLowThreshold = 220
  _MidHighThreshold = 570
  _MidLowThreshold = 420
 

  ' enumerate Nunchuck states
  #0, _NotAligned, _NegativeXAligned, _PositiveXAligned, _NegativeYAligned, {
    } _PositiveYAligned, _NegativeZAligned, _PositiveZAligned

  ' hourMode enumeration
  #0, _AmPmHours, _MilitaryHours

  ' digitMoveFlag enumeration
  #0, _NoMove, _LeftMove, _RightMove
  
VAR

  long electricalColumn, electricalRow, fequency, pattern, oldPattern
  long pulseWidthS
  
  long globalIndex, duration, globalNumber
  long segments[11], highBinary, lowBinary
  long amHours, mHours, minutes, seconds, years, months, date, day
  long clockStack[Header#_StackSize]
  long nordicStack[Header#_StackSize], gobalErrorCount
  long debugLock, nordicLock, zComLock, nordicOjectReturn
  long longToDisplayPtr[3], countDownMode
  long countdownHundredths, countdownSeconds, countdownMinutes
  long tempHundredths, tempSeconds, tempMinutes
  long clockTime, oneSecond, flashCog
  long lastFlash, flashInterval, settingTriggerTime, settingTriggerInterval
  long doubleButtonTime, doubleButtonInterval, i2cLock, clockState 
  
  'long sharedTime
  word axRaw, ayRaw, azRaw                              
  byte jx, jy, bc, bz
  
  byte globalChangeFlag, interuptFlag, dayOfWeek
  byte nordicRxBuffer[32]
  byte setCount, newDataID, lastDataID, newDataFlag, flashFlag[3], lockedFlash[3]
  byte flashState, oldFlashState, settingMode
  byte singleButtonCount', singleButtonHeldFlag
  byte previousNunchuckOrientation, nunchuckOrientation, previousButton, currentButton
  byte bothButtons, noButton, setState, digitsToSet, previousHourMode, hourMode
  byte digitMoveFlag, previousDisplayMode, displayMode
  
OBJ

  Header : "Header110131a"
  shift[2] : "74HC595_MultiPWM"                         ' two added cog
  Com : "pcFullDuplexSerial4FC"                         ' one added cog
  'led : "Flash"
  Nordic : "Nordic100923a"             ' no added cog.
  Nunchuck : "jm_nunchuk_ez_v3" 'NunchuckPointer101009f"
  Clock: "DS1307_RTCEngine"
  
PUB Main | localIndex, localCharacter, count

  Com.Init      
  Com.AddPort(_Debug, 31, 30, -1, -1, 0, 0, Header#_DebugBaud)
  Com.Start                                                   ' 2 cogs 
  debugLock := locknew                                            
  waitcnt(clkfreq * 2 + cnt)
  repeat until not lockset(debugLock)
  Com.str(_Debug, string(13, "After Serial Start"))
  lockclr(debugLock)
  
  flashCog := _FlashOff

  hourMode := _AmPmHours
  repeat until not lockset(debugLock)
  Com.str(_Debug, string(13, "Before SetDisplay"))
  lockclr(debugLock)
  shift[0].start(_ShiftRegisterClockA, _ShiftRegisterLatchA, _ShiftRegisterDataA)                       ' 4 cogs
  shift[1].start(_ShiftRegisterClockB, _ShiftRegisterLatchB, _ShiftRegisterDataB)                       ' 5 cogs 
  waitcnt(clkfreq/4 + cnt)                                                                              

  SetDisplay
  repeat until not lockset(debugLock)
  Com.str(_Debug, string(13, "After SetDisplay"))
  lockclr(debugLock)
  previousDisplayMode := 255
  segments[0] := Character0
  segments[1] := Character1
  segments[2] := Character2
  segments[3] := Character3
  segments[4] := Character4
  segments[5] := Character5
  segments[6] := Character6
  segments[7] := Character7
  segments[8] := Character8
  segments[9] := Character9
  segments[10] := CharacterDP
  duration := _InitialDuration
  globalIndex := -1
  globalChangeFlag := 0

                                    ' used for debug output, not input
  'nordicLock := locknew
  'zComLock := locknew
  ' Required:  Initialize the object.
                         
  
  
  ' Debugging:  Initialize serial object
 
  'led.start(23, 500, 0)
  'waitcnt(clkfreq/4 + cnt)
  repeat until not lockset(debugLock)
  Com.str(_Debug, string(13, "Before MainLoop Start"))
  lockclr(debugLock)
  localCharacter := cognew(MainLoop, @nordicStack)                                                   ' 6 cogs
  i2cLock := locknew
  repeat until not lockset(debugLock)
  Com.str(_Debug, string(13, "Before Nunchuck Init"))
  lockclr(debugLock)
  repeat until not lockset(i2cLock)
  
  Nunchuck.init(_I2cClock, _I2cData)                                      
  lockclr(i2cLock) 
  repeat until not lockset(debugLock)
  Com.str(_Debug, string(13, "After Nunchuck Init"))
  lockclr(debugLock)
  clockState := Clock.RTCEngineStart(_I2cData, _I2cClock, i2cLock)
  repeat until not lockset(debugLock)
  Com.str(_Debug, string(13, "After Clock Start"))
  lockclr(debugLock)
  
  waitcnt(clkfreq/4 + cnt)
  if clockState
    Clock.readTime 
    mHours := Clock.clockHour
    amHours := mHours // 12
    if amHours == 0
      amHours := 12 
    minutes := Clock.clockMinute
    seconds := Clock.clockSecond
    displayMode := _ClockDisplay
    years := Clock.clockYear - 2000
    day := Clock.clockDay
    date := Clock.clockDate
    months := Clock.clockMonth
    repeat until not lockset(debugLock)
    Com.str(_Debug, string(13, "Clock Found"))
    lockclr(debugLock)
  
  repeat until not lockset(debugLock)
  Com.str(_Debug, string(13, "programName = "))
  Com.str(_Debug, @programName)
  Com.str(_Debug, string("LightLed cog is "))
  Com.dec(_Debug, localCharacter)
  Com.tx(_Debug, 13)                                
  Com.str(_Debug, string("zComLock = "))
  Com.dec(_Debug, zComLock)
  Com.tx(_Debug, 13)
  Com.str(_Debug, string("nordicOjectReturn = "))
  Com.dec(_Debug, nordicOjectReturn)
  Com.tx(_Debug, 13) 
  lockclr(debugLock)
 
  fequency := Header#_DefaultLedFrequency

  pulseWidthS := Header#_DefaultClockDutyCycle
  repeat until not lockset(debugLock)
  Com.str(_Debug, string("Enter t to set time.", 13)) 
  'Com.str(_Debug, string("Enter c to set calendar.", 13))  
  Com.str(_Debug, string("Enter c to set a new countdown time.", 13))  
  Com.str(_Debug, string("Hit spacebar to pause countdown.", 13))  
  Com.str(_Debug, string("Enter r to reset countdown.", 13))  
  Com.str(_Debug, string("Enter x to use clock.", 13))  
  Com.str(_Debug, string("Enter f to change fequency of all LEDs.", 13))       
  Com.str(_Debug, string("Enter o to turn all LEDs off.", 13)) 
  lockclr(debugLock)
  count := 99800                                        ' used when testing display
  interuptFlag := 0
  repeat
        
    localCharacter := Com.Rxcheck(_Debug) 
    
    if localCharacter == "f"                                           
      ChangeFrequency
    elseif localCharacter == "o"                                         
      globalIndex := -1
      shift[0].out(0)
      shift[1].out(0)
      globalChangeFlag := 1
    elseif localCharacter == "s"
      \PrepareToDisplayNumber
      'Com.str(_Debug, string("Ready to display"))
      'Com.dec(_Debug, globalNumber)
      'Com.tx(_Debug, 13)
      DisplayNumber(globalNumber) 
    elseif localCharacter == "t"
      EnterTime
    elseif localCharacter == "c"
      EnterCountdown
    elseif localCharacter == "x"
      countdownMode := _ClockModeCountdown
    elseif localCharacter == "r"
      countdownMode := _ResetCountdown
    elseif localCharacter == 32
      if countdownMode == _Countdown
        countdownMode := _PauseCountdown
      elseif countdownMode == _PauseCountdown or countdownMode == _ReadyToCountdown
        countdownMode := _Countdown
      elseif countdownMode == _EndOfCountdown
        countdownMode := _ResetCountdown

      'SetCalendar
    
    else
      interuptFlag := 0
    
      
   'waitcnt(clkfreq/10 + cnt)

PRI DListens(comType) | localTemp', localIndex

  localTemp := 0
  
  if comType == _ComNordic
    repeat until not lockset(debugLock)
    Com.str(_Debug, string(13,"DListens method"))
    Com.str(_Debug, string(13,"message from board "))
    Com.tx(_Debug, nordicRxBuffer[3])
    Com.str(_Debug, string(" isn't suported yet.", 13))
    if nordicRxBuffer[5] == Header#_Command                    ' nordicRxBuffer[4] was dataCount 
    
    {else if nordicRxBuffer[5] == Header#_Enquire   
      if nordicRxBuffer[6] == Header#_LedSingle or nordicRxBuffer[6] == Header#_LedGroup
        if globalIndex > 1    nordicTxBuff[] := Header#_LedGroup
        TransmitString(pointer)   }

          
PUB MainLoop | localLoop, localIndex, localTime, localSize, localSeconds, loopSeconds, {
                } localCdHundredths, localCdSeconds, localCdMinutes
  {
  nordicOjectReturn := Nordic.Init( _NordicCsPin, _NordicCePin, _NordicClockPin, _NordicReadyPin, _NordicDataPin )    'Initialize TRF24G
  Nordic.configure( @nordicConfig )
  Nordic.setmode( 1 )                                   '1 = RX_ON   3 = TX_ON
  }
  localLoop := 0
  
  localSeconds := 0
  clockTime := cnt
  oneSecond := clkfreq
  flashInterval := oneSecond / 4
  settingTriggerInterval := oneSecond
  doubleButtonInterval := oneSecond / 10
  loopSeconds := 10
  Display(_HoursPlace) ' hours
  Display(_MinutesPlace) ' minutes
  Display(_SecondsPlace) ' seconds
  lastFlash := cnt
  singleButtonCount := 0
    
  repeat                                                ' TransmitString method is watching for acknowledgements
    'repeat until not lockset(nordicLock)                ' But not yet.
    if displayMode <> previousDisplayMode
      SetDisplay
    CheckForFlashingDigits

    CheckSettingStates

    if setState == _SettableState
      SetSetting
        
    if countdownMode > _ClockModeCountdown
      
      CountdownWatch
     
        
    CheckClock
     
      
     
    {  
    if ina[_NordicReadyPin] == 1                            ' Ignore acknowledgements here.
      
      Nordic.recv(@nordicRxBuffer)
      localIndex := 0
      repeat until not lockset(debugLock)
      Com.str(_Debug, string(13, "MainLoop method", 13))
      Com.str(_Debug, string("Recived : "))
      localSize := strsize(@nordicRxBuffer)             ' ** is Rx complete at this point?
      repeat localIndex from 0 to localSize
        Com.tx(_Debug, 36)
        Com.hex(_Debug, nordicRxBuffer[localIndex], 2)
        if nordicRxBuffer[localIndex] > 32
          Com.tx(_Debug, 44)
          Com.tx(_Debug, nordicRxBuffer[localIndex]) 
        Com.tx(_Debug, 32)
      lockclr(debugLock)
      if nordicRxBuffer[0] == Header#_StartOfHeader and  nordicRxBuffer[1] == Header#_StartOfText
        if nordicRxBuffer[2] < "a" or nordicRxBuffer[2] > "z" 
          repeat until not lockset(debugLock)
          ComError(_ComNordic, 2, nordicRxBuffer[2], "d")
          lockclr(debugLock)
        newDataID := nordicRxBuffer[4]
        nordicTxBuff[5] := "a"        'a for acknowledge
        nordicTxBuff[6] := newDataID
        nordicTxBuff[7] := 13
        nordicTxBuff[8] := 0
        Nordic.xmit(@nordicTxBuff)
        waitcnt(clkfreq/100 + cnt)
        if newDataID <> lastDataID
          newDataFlag := nordicRxBuffer[2]              ' newDataFlag equals distination board to indicate new data
                                                        ' it's zero otherwise
          lastDataID := newDataID 
        else
          newDataFlag := 0
        case newDataFlag
          '***Beep.BeepBeep
          "a".."c":
            repeat until not lockset(debugLock)
            Com.str(_Debug, string(13,"MainLoop method"))
            Com.str(_Debug, string(13,"board "))
            Com.tx(_Debug, newDataFlag)
            Com.str(_Debug, string(" isn't suported yet.", 13))
            lockclr(debugLock)
          "d":
            repeat until not lockset(debugLock)
            Com.str(_Debug, string(13,"MainLoop method"))
            Com.str(_Debug, string(13,"board "))
            Com.tx(_Debug, newDataFlag)
            Com.str(_Debug, string(" is suported.", 13))
            lockclr(debugLock)
            DAction(_ComNordic)
          "e".."y":
            repeat until not lockset(debugLock)
            Com.str(_Debug, string(13,"MainLoop method"))
            Com.str(_Debug, string(13,"board "))
            Com.tx(_Debug, newDataFlag)
            Com.str(_Debug, string(" isn't suported yet.", 13))
            lockclr(debugLock)
          

          other:
            ' this shouldn't happen
            repeat until not lockset(debugLock)
            Com.str(_Debug, string(13,"MainLoop method ***Case other***"))
            Com.str(_Debug, string(13,"board "))
            Com.tx(_Debug, newDataFlag)
            Com.str(_Debug, string(13, " *** This should never be seen ***", 13))
            lockclr(debugLock)
      else
        repeat until not lockset(debugLock)
        ComError(_ComNordic, 0, nordicRxBuffer[0], Header#_StartOfHeader)
        lockclr(debugLock) 
        'lockclr(nordicOjectReturn)
        'lockret(nordicOjectReturn)
        'nordicOjectReturn := Nordic.Init( _NordicCsPin, _NordicCePin, _NordicClockPin, _NordicReadyPin, _NordicDataPin )    'Initialize TRF24G
        'Nordic.configure( @nordicConfig )
        'Nordic.setmode( 1 )
              }
      
    'lockclr(nordicLock)
    
    'waitcnt(clkfreq/100 + cnt)
    localLoop++
    
PUB SetDisplay

  case displayMode
    _Countdown0Display:
      longToDisplayPtr[_SecondsPlace] := @countdownHundredths
      longToDisplayPtr[_MinutesPlace] := @countdownSeconds
      longToDisplayPtr[_HoursPlace] := @countdownMinutes
    other: '_ClockDisplay:
      longToDisplayPtr[_SecondsPlace] := @seconds
      longToDisplayPtr[_MinutesPlace] := @minutes
      if hourMode == _MilitaryHours
        longToDisplayPtr[_HoursPlace] := @mHours
      else
        longToDisplayPtr[_HoursPlace] := @amHours
    '_Timer0Display
  Display(_HoursPlace) ' hours
  Display(_MinutesPlace) ' minutes
  Display(_SecondsPlace) ' seconds

PUB SetSetting | localTemp, localAddress, localHighLimit

  if (currentButton == "c" or currentButton == "z") ' transitional values
    return
  if currentButton <> previousButton 
    digitsToSet := _HoursPlace
    if (currentButton == "C" or currentButton == "Z")     
      FlashOnly(digitsToSet)
      digitMoveFlag := _NoMove
    else
      FlashAll
      displayMode := _ClockDisplay
      SetDisplay
    DisplayFlash

    return
  elseif currentButton == "2" or currentButton == "0" 
    repeat until not lockset(debugLock)
    Com.str(_Debug, string(13, "Double or nothing with buttons."))   
    lockclr(debugLock)  
    return
  ' Nunchuck joystick: left and back are low values, right and forward are high values  
  if AxisCentered("y")
    repeat until not lockset(debugLock)
    Com.str(_Debug, string(13, "Y centered."))
    Com.str(_Debug, string(", jx = "))
    Com.dec(_Debug, jx)
    lockclr(debugLock)
    DisplayDigitMoveFlag
  
    if digitMoveFlag == _NoMove   ' x previously centered       
      if jx < (_JxLeftCenterEdge - _ChangeDigitThreshold)        
        if digitsToSet <> _HoursPlace
          digitsToSet++
          FlashOnly(digitsToSet)
          repeat until not lockset(debugLock)
          Com.str(_Debug, string(13, "                   +digitsToSet = "))
          Com.dec(_Debug, digitsToSet)
          lockclr(debugLock)
        digitMoveFlag := _LeftMove
        DisplayDigitMoveFlag 
      elseif jx > (_JxRightCenterEdge + _ChangeDigitThreshold)        
        if digitsToSet <> _SecondsPlace
          digitsToSet--
          FlashOnly(digitsToSet)
          repeat until not lockset(debugLock)
          Com.str(_Debug, string(13, "                   -digitsToSet = "))
          Com.dec(_Debug, digitsToSet)
          lockclr(debugLock)
        digitMoveFlag := _RightMove
        DisplayDigitMoveFlag
    elseif jx > _JxLeftCenterEdge and jx < _JxRightCenterEdge
      digitMoveFlag := _NoMove
      DisplayDigitMoveFlag
  elseif AxisCentered("x")
    repeat until not lockset(debugLock)
    Com.str(_Debug, string(13, "X centered."))
    lockclr(debugLock)
    if jy > _JyForwardCenterEdge
      result := (jy - _JyForwardCenterEdge) / _SettingDivider
    elseif jy < _JyBackwardCenterEdge
      result := (jy - _JyBackwardCenterEdge) / _SettingDivider
    else
      result := 0
    repeat until not lockset(debugLock) 
    Com.str(_Debug, string(" result = "))
    Com.dec(_Debug, result)
    lockclr(debugLock)
    if currentButton := "C"
      repeat until not lockset(debugLock)
      Com.str(_Debug, string(13, "C pressed."))
      lockclr(debugLock)
      displayMode := _ClockDisplay
      SetDisplay
      case digitsToSet
        _SecondsPlace:
          localTemp := seconds
          localAddress := @seconds
          localHighLimit := 59
          repeat until not lockset(debugLock)
          Com.str(_Debug, string(" seconds = "))
          lockclr(debugLock)

        _MinutesPlace:
          localTemp := minutes
          localAddress := @minutes
          localHighLimit := 59
          repeat until not lockset(debugLock)
          Com.str(_Debug, string(" minutes = ")) 
          lockclr(debugLock)
        _HoursPlace:
          localTemp := mHours
          localAddress := @mHours
          localHighLimit := 23
          repeat until not lockset(debugLock)
          Com.str(_Debug, string(" hours = ")) 
          lockclr(debugLock)
    elseif currentButton := "Z"
      repeat until not lockset(debugLock)
      Com.str(_Debug, string(13, "C pressed."))   
      lockclr(debugLock)  
      displayMode := _Countdown0Display
      SetDisplay
      case digitsToSet
        _SecondsPlace:
          localTemp := countdownHundredths
          localAddress := @countdownHundredths
          localHighLimit := 99
          repeat until not lockset(debugLock)
          Com.str(_Debug, string(" countdownHundredths = ")) 
          lockclr(debugLock)
        _MinutesPlace:
          localTemp := countdownSeconds
          localAddress := @countdownSeconds
          localHighLimit := 59
          repeat until not lockset(debugLock)
          Com.str(_Debug, string(" countdownSeconds = ")) 
          lockclr(debugLock)
        _HoursPlace:
          localTemp := countdownMinutes
          localAddress := @countdownMinutes
          localHighLimit := 23
          repeat until not lockset(debugLock)
          Com.str(_Debug, string(" countdownMinutes = ")) 
          lockclr(debugLock)
    longToDisplayPtr[digitsToSet] := localAddress
    if localTemp + result > localHighLimit
      long[localAddress] := localHighLimit
    elseif localTemp + result < 0
      long[localAddress] := 0
    else
      long[localAddress] := localTemp + result   
    repeat until not lockset(debugLock)    
    Com.dec(_Debug, long[localAddress])
    Com.str(_Debug, string(" change amount = "))
    Com.dec(_Debug, result)  
    lockclr(debugLock)
    waitcnt(clkfreq + cnt)
    
PUB AxisCentered(localAxis)

  if localAxis == "x"
    if jx > (_JxLeftCenterEdge - _OtherAxisLimit) and jx < (_JxRightCenterEdge + _OtherAxisLimit)
      result := true
    else
      result := false
  else      
    if jy > (_JyBackwardCenterEdge - _OtherAxisLimit) and jy < (_JyForwardCenterEdge + _OtherAxisLimit)
      result := true
    else
      result := false
      
PUB CheckSettingStates

  previousButton := currentButton
  ReadNunchuck
  if bc == 0 and bz == 0
    currentButton := "0"
    singleButtonCount := 0
    
  elseif bc == 1 and bz == 1
    currentButton := "2"
    singleButtonCount := 0
   
  else
    if bc == 1
      if previousButton == "c"
        if ++singleButtonCount => _SingleButtonCountThreshold
          currentButton := "C"
        else
          currentButton := "c"
      elseif previousButton == "C"
        currentButton := "C"
      else
        currentButton := "c"
        singleButtonCount := 0   
    else
      if previousButton == "z"
        if ++singleButtonCount => _SingleButtonCountThreshold
          currentButton := "Z"
        else
          currentButton := "z"
      elseif previousButton == "Z"
        currentButton := "Z"
      else
        currentButton := "z"
        singleButtonCount := 0  
    
  repeat until not lockset(debugLock)
  Com.str(_Debug, string(13, " currentButton = "))
  Com.tx(_Debug, currentButton)
  lockclr(debugLock)

  if currentButton == "0"  
    if nunchuckOrientation == _PositiveZAligned
      noButton := _UpNoButton
      
      if bothButtons == _DownToUpBoth
        bothButtons := _FinalReleaseBoth
        Change
        ToggleSettingState
      else
        bothButtons := _ReleasedSinceDownBoth
          
    elseif nunchuckOrientation == _NegativeZAligned
      if noButton := _UpNoButton
        noButton := _UpToDownNoButton
        Change
  elseif currentButton == "2"  
    if nunchuckOrientation == _NegativeZAligned
      if noButton == _UpToDownNoButton        
        settingTriggerTime := cnt                
        noButton := _PressedSinceUpButton
        bothButtons := _DownBoth
        Change
      elseif bothButtons == _DownBoth and cnt - settingTriggerTime > settingTriggerInterval
        bothButtons := _DownHeldBoth
        Change       
        'return
    elseif nunchuckOrientation == _PositiveZAligned
      if bothButtons == _DownHeldBoth
        bothButtons := _DownToUpBoth
      
  else
    if currentButton == "C" or currentButton == "Z"
      noButton := _PressedSinceUpButton
      bothButtons := _ReleasedSinceDownBoth 
 
  'DisplayState
  'DisplayNoButton
  'DisplayBothButtons
  
PRI Change

  repeat until not lockset(debugLock)
  Com.str(_Debug, string(13, " *********************** Change ****************************** "))
  lockclr(debugLock)
  DisplayState
  DisplayNoButton
  DisplayBothButtons
  waitcnt(clkfreq / 2 + cnt)      

PRI ToggleSettingState

  repeat until not lockset(debugLock)
  Com.str(_Debug, string(13, " **************************************************************** "))
  lockclr(debugLock)
  digitMoveFlag := _NoMove
  if setState == _SettableState
    setState := _NormalState
    hourMode := previousHourMode
    flashFlag[_HoursPlace] := 0
    flashFlag[_MinutesPlace] := 0
    flashFlag[_SecondsPlace] := 0
  else
    setState := _SettableState
    digitsToSet := _HoursPlace
    previousHourMode := hourMode
    hourMode := _MilitaryHours
  DisplayState
  DisplayNoButton
  DisplayBothButtons
  waitcnt(clkfreq * 2 + cnt)
    
PRI DisplayState

  repeat until not lockset(debugLock)
  Com.str(_Debug, string(13, " setState = "))
  Com.dec(_Debug, setState)
  case setState
    _NormalState:
      Com.str(_Debug, string(13, "  _NormalState"))  
    _SettableState:
      Com.str(_Debug, string(13, "  _SettableState"))
  lockclr(debugLock)
      
PRI DisplayNoButton
        
  repeat until not lockset(debugLock)
  Com.str(_Debug, string(13, " noButton = "))
  Com.dec(_Debug, noButton)
  case noButton
    _PressedSinceUpButton:
      Com.str(_Debug, string(13, "  _PressedSinceUpButton"))  
    _UpNoButton:
      Com.str(_Debug, string(13, "  _UpNoButton"))  
    _UpToDownNoButton:
      Com.str(_Debug, string(13, "  _UpToDownNoButton"))
  lockclr(debugLock)
        
PRI DisplayBothButtons
        
  repeat until not lockset(debugLock)
  Com.str(_Debug, string(13, " bothButtons = "))
  Com.dec(_Debug, bothButtons)
  case bothButtons
    _ReleasedSinceDownBoth:
      Com.str(_Debug, string(13, "  _ReleasedSinceDownBoth"))  
    _DownBoth:
      Com.str(_Debug, string(13, "  _DownBoth"))
    _DownHeldBoth:
      Com.str(_Debug, string(13, "  _DownHeldBoth"))  
    _DownToUpBoth:
      Com.str(_Debug, string(13, "  _DownToUpBoth"))  
    _FinalReleaseBoth:
      Com.str(_Debug, string(13, "  _FinalReleaseBoth"))  
  lockclr(debugLock)

PRI DisplayDigitMoveFlag

  repeat until not lockset(debugLock)
  Com.str(_Debug, string(13, " digitMoveFlag = "))
  Com.dec(_Debug, digitMoveFlag)
  case digitMoveFlag
    _NoMove:
      Com.str(_Debug, string(13, "  _NoMove"))  
    _LeftMove:
      Com.str(_Debug, string(13, "  _LeftMove"))  
    _RightMove:
      Com.str(_Debug, string(13, "  _RightMove"))  
  lockclr(debugLock)
              
PRI DisplayFlash

  repeat until not lockset(debugLock)
  Com.str(_Debug, string(13, "flashFlag[0] = "))
  Com.dec(_Debug, flashFlag[0])
  Com.str(_Debug, string(", flashFlag[1] = "))
  Com.dec(_Debug, flashFlag[1])
  Com.str(_Debug, string(", flashFlag[2] = "))
  Com.dec(_Debug, flashFlag[2])
  Com.str(_Debug, string(", digitsToSet = "))
  Com.dec(_Debug, digitsToSet)  
  lockclr(debugLock)

PRI FlashOnly(localDigits)

  repeat result from 0 to 2
    if result == localDigits
      flashFlag[result] := 1
    else
      flashFlag[result] := 0

PRI FlashAll

  repeat result from 0 to 2
    flashFlag[result] := 1
    
PRI FlashOff

  repeat result from 0 to 2
    flashFlag[result] := 0
    
PUB CountdownWatch | localHundreth, localTime, previousMode

  localHundreth := clkfreq / 100

  repeat while countdownMode > _ClockModeCountdown
    CheckClock
    
    if countdownMode == _ResetCountdown
   
      tempHundredths := countdownHundredths
      tempSeconds := countdownSeconds
      tempMinutes := countdownMinutes
      displayMode := _Countdown0Display
      SetDisplay
      previousMode := _ResetCountdown
      countdownMode := _ReadyToCountdown
      
    elseif countdownMode == _Countdown and previousMode <> _Countdown
      localTime := cnt
      previousMode := _Countdown
    elseif countdownMode == _Countdown
      if (cnt - localTime) => localHundreth
        localTime += localHundreth
        if tempHundredths == 0
          tempHundredths := 99
          if tempSeconds == 0
            tempSeconds := 59
            if tempMinutes == 0
              tempHundredths := 0
              tempSeconds := 0
              countdownMode := _EndOfCountdown
            else
              tempMinutes--
            Display(_HoursPlace)  
          else
            tempSeconds--
            CheckClock
          Display(_MinutesPlace)  
        else
          tempHundredths--
        Display(_SecondsPlace)          
  displayMode := _ClockDisplay
  SetDisplay
       
PRI DAction(comType) | localTemp', localIndex

  localTemp := 0
  
  if comType == _ComNordic
    repeat until not lockset(debugLock)
    Com.str(_Debug, string(13,"DAction method"))
    Com.str(_Debug, string(13,"message from board "))
    Com.tx(_Debug, nordicRxBuffer[3])
    Com.str(_Debug, string(".", 13, "Parsing Message.", 13))
    lockclr(debugLock)
    if nordicRxBuffer[5] == Header#_Command                    ' nordicRxBuffer[4] was dataCount 
      
    {else if nordicRxBuffer[5] == Header#_Enquire   
      if nordicRxBuffer[6] == Header#_LedSingle or nordicRxBuffer[6] == Header#_LedGroup
        if globalIndex > 1    nordicTxBuff[] := Header#_LedGroup
        TransmitString(pointer)   }
    
PUB EnterTime | localCharacter

  repeat until not lockset(debugLock)
  Com.str(_Debug, string(13, "Enter two digit hour : "))
  mHours := 0
  repeat 2   
    localCharacter := Com.rx(_Debug)
    if localCharacter => "0" and localCharacter =< "9"
      mHours := (mHours * 10) + (localCharacter - 48)
  Com.str(_Debug, string(13, "You entered "))
  Com.dec(_Debug, mHours)
  Com.str(_Debug, string(" hours.", 13, "Enter two digit minutes : "))
  minutes := 0
  seconds := 0
  repeat 2   
    localCharacter := Com.rx(_Debug)
    seconds := 0
    if localCharacter => "0" and localCharacter =< "9"
      minutes := (minutes * 10) + (localCharacter - 48)
  Com.str(_Debug, string(13, "You entered "))
  Com.dec(_Debug, minutes)
  Com.str(_Debug, string(" minutes."))
  lockclr(debugLock)
  seconds := 0

  longToDisplayPtr[_SecondsPlace] := @seconds
  longToDisplayPtr[_MinutesPlace] := @minutes
  longToDisplayPtr[_HoursPlace] := @mHours
  
  Display(_HoursPlace) ' hours
  Display(_MinutesPlace) ' minutes
  Display(_SecondsPlace) ' seconds
  
PUB EnterCountdown | localCharacter

  repeat until not lockset(debugLock)
  Com.str(_Debug, string(13, "Enter two digit minutes : "))
  countdownMinutes := 0
  repeat 2   
    localCharacter := Com.rx(_Debug)
    if localCharacter => "0" and localCharacter =< "9"
      countdownMinutes := (countdownMinutes * 10) + (localCharacter - 48)
  Com.str(_Debug, string(13, "You entered "))
  Com.dec(_Debug, countdownMinutes)
  Com.str(_Debug, string(" minutes.", 13, "Enter two digit seconds : "))
  countdownSeconds := 0
  countdownHundredths := 0
  repeat 2   
    localCharacter := Com.rx(_Debug)
    if localCharacter => "0" and localCharacter =< "9"
      countdownSeconds := (countdownSeconds * 10) + (localCharacter - 48)
  Com.str(_Debug, string(13, "You entered "))
  Com.dec(_Debug, countdownSeconds)
  Com.str(_Debug, string(" seconds."))
  lockclr(debugLock)
  countdownHundredths := 0

  {longToDisplayPtr[_SecondsPlace] := @countdownHundredths
  longToDisplayPtr[_MinutesPlace] := @countdownMinutes
  longToDisplayPtr[_HoursPlace] := @countdownSeconds
  }
  countDownMode := _ResetCountdown
  {Display(_HoursPlace) ' hours
  Display(_MinutesPlace) ' minutes
  Display(_SecondsPlace) ' seconds
  }
PUB SetCalendar | localCharacter 

  repeat until not lockset(debugLock)
  Com.str(_Debug, string(13, "Enter four digit year : "))
  years := 0
  repeat while years < 1000  
    localCharacter := Com.rx(_Debug)
    if localCharacter => "0" and localCharacter =< "9"
      mHours := (mHours * 10) + (localCharacter - 48)
    else
      Com.str(_Debug, string(13, "So far the year is "))
      Com.dec(_Debug, years)
      Com.str(_Debug, string(13, "Enter remaining digits : "))
      
  Com.str(_Debug, string(13, "Enter two digit month : "))
  months := 0
  repeat 2   
    localCharacter := Com.rx(_Debug)
    seconds := 0
    if localCharacter => "0" and localCharacter =< "9"
      months := (months * 10) + (localCharacter - 48)
  Com.str(_Debug, string(13, "Enter two digit date : "))
  date := 0
  repeat 2   
    localCharacter := Com.rx(_Debug)
    seconds := 0
    if localCharacter => "0" and localCharacter =< "9"
      date := (date * 10) + (localCharacter - 48)
  Com.str(_Debug, string(13, "Enter one digit day of week : "))
  Com.str(_Debug, string(13, "Sunday = 1, Monday = 2, Tuesday = 3, Wednesday = 4"))
  Com.str(_Debug, string(13, "Thursday = 5, Friday = 6, Saturday = 7", 13))

  dayOfWeek := 0
  localCharacter := Com.rx(_Debug)
  lockclr(debugLock)
  seconds := 0
  if localCharacter => "0" and localCharacter =< "9"
    dayOfWeek := (localCharacter - 48)
  
PUB Display(twoDigits) | localDigit, localNumber, firstDigitFlag, localIndex, numberToDisplay

  localNumber := 10                   
  highBinary := 0
  lowBinary := 0
  firstDigitFlag := 0
  
  shift[0].SetPWM(7, fequency, pulseWidthS)             ' turn on colons
  shift[0].SetPWM(15, fequency, pulseWidthS)
  shift[1].SetPWM(7, fequency, pulseWidthS)
  shift[1].SetPWM(23, fequency, pulseWidthS)
  
  
  if twoDigits == _HoursPlace             ' Display Hours
    numberToDisplay := long[longToDisplayPtr[_HoursPlace]]
    repeat 2                      ' Fill highest three digits, 
      highBinary <<= 8 
      localDigit :=  numberToDisplay / localNumber
      if localDigit >  0
        firstDigitFlag := 1
      numberToDisplay //= localNumber
      localNumber /= 10
      if firstDigitFlag == 1
        highBinary += segments[localDigit]

    highBinary <<= 16  
    lowBinary <<= 16
    'Com.str(_Debug, string(13, "2 highBinary = %"))
    'debug.bin(highBinary, 32)
    'Com.tx(_Debug, 13)
    'Com.str(_Debug, string(13, "lowBinary = %"))
    'debug.bin(lowBinary, 32)
    'Com.tx(_Debug, 13)
    localDigit := 1
    repeat localIndex from 0 to 6
      shift[0].low(localIndex)
    repeat localIndex from 8 to 14
      shift[0].low(localIndex)
    localIndex := 0
    'shift[0].low(0)
    repeat while localDigit > 0
      localDigit := >|highBinary
      if localDigit > 0 
        localIndex += 33 - localDigit
        highBinary <<= (33 - localDigit)  
        shift[0].SetPWM(localIndex - 1 , fequency, pulseWidthS)
        'Com.str(_Debug, string(13, "highBinary = %"))
        'debug.bin(highBinary, 32)
        'Com.tx(_Debug, 13)
        'waitcnt(clkfreq * 1 + cnt)
      
  elseif twoDigits == _MinutesPlace             ' Display Minutes
    numberToDisplay := long[longToDisplayPtr[_MinutesPlace]]
     
    localDigit :=  numberToDisplay / localNumber      
    numberToDisplay //= localNumber
    localNumber /= 10     
    highBinary := segments[localDigit]
    highBinary <<= 8
    localDigit := 1
    'Com.str(_Debug, string(13, "1 minutes = "))
    'Com.dec(_Debug, minutes)
    'Com.tx(_Debug, 13)
    'Com.str(_Debug, string(13, "1 highBinary = %"))
    'debug.bin(highBinary, 32)
    'Com.tx(_Debug, 13)
    
    repeat localIndex from 16 to 23
      shift[0].low(localIndex)
    localIndex := 0
    repeat while localDigit > 0
      localDigit := >|highBinary
      if localDigit > 0 
        localIndex += 33 - localDigit
        highBinary <<= (33 - localDigit)  
        shift[0].SetPWM(localIndex - 1 , fequency, pulseWidthS)
        
    lowBinary := segments[numberToDisplay]
    lowBinary <<= 24
    localDigit := 1
    'Com.str(_Debug, string(13, "1 numberToDisplay = "))
    'Com.dec(_Debug, numberToDisplay)
    'Com.tx(_Debug, 13)
    'Com.str(_Debug, string(13, "1 lowBinary = %"))
    'debug.bin(lowBinary, 32)
    'Com.tx(_Debug, 13)
    
    repeat localIndex from 0 to 6
      shift[1].low(localIndex)
    localIndex := 0
    repeat while localDigit > 0
      localDigit := >|lowBinary
      if localDigit > 0 
        localIndex += 33 - localDigit
        lowBinary <<= (33 - localDigit)  
        shift[1].SetPWM(localIndex - 1 , fequency, pulseWidthS)
    
  elseif twoDigits == _SecondsPlace             ' Display Seconds
    numberToDisplay := long[longToDisplayPtr[_SecondsPlace]]
    repeat 2                      ' Fill highest three digits, 
      lowBinary <<= 8 
      localDigit :=  numberToDisplay / localNumber
      numberToDisplay //= localNumber
      localNumber /= 10
      lowBinary += segments[localDigit]

    lowBinary <<= 8
    localDigit := 1
    'Com.str(_Debug, string(13, "0 seconds = "))
    'Com.dec(_Debug, seconds)
    'Com.tx(_Debug, 13)
    'Com.str(_Debug, string(13, "0 lowBinary = %"))
    'debug.bin(lowBinary, 32)
    'Com.tx(_Debug, 13)
    repeat localIndex from 8 to 22
      shift[1].low(localIndex)
    localIndex := 0
    repeat while localDigit > 0
      localDigit := >|lowBinary
      if localDigit > 0 
        localIndex += 33 - localDigit
        lowBinary <<= (33 - localDigit)  
        shift[1].SetPWM(localIndex - 1 , fequency, pulseWidthS)
           
PUB CheckForFlashingDigits | localIndex
' flash in sets of two
 
  if cnt - lastFlash => flashInterval
    lastFlash += flashInterval
    if flashState == 1
      flashState := 0
    else
      flashState := 1  
 
    if flashState == 1
      if flashFlag[_SecondsPlace] == 1
        lockedFlash[_SecondsPlace] := 1
        repeat localIndex from 8 to 22
          shift[1].low(localIndex)
      if flashFlag[_MinutesPlace] == 1
        lockedFlash[_MinutesPlace] := 1  
        repeat localIndex from 16 to 23
          shift[0].low(localIndex)
        repeat localIndex from 0 to 6
          shift[1].low(localIndex)
      if flashFlag[_HoursPlace] == 1
        lockedFlash[_HoursPlace] := 1  
        repeat localIndex from 0 to 6
          shift[0].low(localIndex)
        repeat localIndex from 8 to 14
          shift[0].low(localIndex)
    else
      repeat localIndex from _SecondsPlace to _HoursPlace
        if lockedFlash[localIndex] == 1
          lockedFlash[localIndex] := 0
          Display(localIndex)

    oldFlashState := flashState
    
PUB DisplayNumber(numberToDisplay) | localDigit, localNumber, firstDigitFlag, localIndex
  '' This method doesn't take in to account decimal points (yet).
  '' This method expects to receive the number as a long, not ASCII format.
  '' I plan to make a seperate ASCII method.

  localNumber := 100_000                   
  highBinary := 0
  lowBinary := 0
  firstDigitFlag := 0
  
  'repeat localIndex
  '  localNumber *= 10

  repeat 3                      ' Fill highest three digits, 
    highBinary <<= 8 
    'if numberToDisplay => localNumber
    localDigit :=  numberToDisplay / localNumber
    if localDigit >  0
      firstDigitFlag := 1
    numberToDisplay //= localNumber
    localNumber /= 10
    if firstDigitFlag == 1
      highBinary += segments[localDigit]
  repeat 3                      ' Fill lowest three digits, 
    lowBinary <<= 8 
    'if numberToDisplay => localNumber
    localDigit :=  numberToDisplay / localNumber
    if localDigit >  0
      firstDigitFlag := 1
    numberToDisplay := numberToDisplay // localNumber
    localNumber /= 10
    if firstDigitFlag == 1
      lowBinary += segments[localDigit]
  highBinary <<= 8  
  lowBinary <<= 8
  'Com.str(_Debug, string(13, "highBinary = %"))
  'debug.bin(highBinary, 32)
  'Com.tx(_Debug, 13)
  'Com.str(_Debug, string(13, "lowBinary = %"))
  'debug.bin(lowBinary, 32)
  'Com.tx(_Debug, 13)
  localDigit := 1
  localIndex := 0
  shift[0].out(0)
  repeat while localDigit > 0
    localDigit := >|highBinary
    if localDigit > 0 
      localIndex += 33 - localDigit
      highBinary <<= (33 - localDigit)  
      shift[0].SetPWM(localIndex - 1 , fequency, pulseWidthS)
      'Com.str(_Debug, string(13, "highBinary = %"))
      'debug.bin(highBinary, 32)
      'Com.tx(_Debug, 13)
      'waitcnt(clkfreq * 1 + cnt)
  
  localDigit := 1
  localIndex := 0
  shift[1].out(0)
  repeat while localDigit > 0
    localDigit := >|lowBinary
    if localDigit > 0
      localIndex += 33 - localDigit
      lowBinary <<= (33 - localDigit)  
      shift[1].SetPWM(localIndex - 1 , fequency, pulseWidthS)
      'Com.str(_Debug, string(13, "lowBinary = %"))
      'debug.bin(lowBinary, 32)
      'Com.tx(_Debug, 13)
      'waitcnt(clkfreq * 1 + cnt)
    
PUB PrepareToDisplayNumber | localCharacter

  'Com.str(_Debug, string(13, "Enter digits to display.", 13))
  globalNumber := 0
  repeat    
    localCharacter := Com.rx(_Debug)
    if localCharacter == 13
      abort
    elseif localCharacter => "0" and localCharacter =< "9"
      globalNumber := (globalNumber * 10) + (localCharacter - 48)
      if globalNumber > 99999
        abort
   waitcnt(clkfreq/10 + cnt)

  
PUB ChangeFrequency | localCharacter, localFreq, freqFlag 

  repeat until not lockset(debugLock)
  repeat while localCharacter <> 13
    localCharacter := Com.rx(_Debug)
    if localCharacter => "0" and localCharacter =< "9"
      localFreq := (localFreq * 10) +  (localCharacter - 48)
      freqFlag := 1
  lockclr(debugLock)
  if freqFlag == 0
    'Com.str(_Debug, string("No fequency selected.", 13))
  elseif localFreq > 1000000 or localFreq < 1
    'Com.str(_Debug, string("fequency out of range.  1 to 1,000,000 are valid options.", 13))
  else
    'Com.str(_Debug, string("New fequency is "))
    'Com.dec(_Debug, localFreq)
    'Com.tx(_Debug, 13)
    'Com.str(_Debug, string("This new fequency will be used with the next power change.", 13)) 
    fequency := localFreq                    
    globalChangeFlag := 1
        
PRI CheckClock | {localTime, oneSecond,} daysInMonth

  if (cnt - clockTime) => oneSecond
    
    clockTime += oneSecond
         
    if ++seconds > 59
      seconds := 0      
      if ++minutes > 59
        minutes := 0
        
        if ++mhours > 24
          
          mHours := 0
          if ++date > daysInMonth
            date := 1
            if ++months > 12
              months := 1
              years++            
            daysInMonth := lookup(months: 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31)
            if months == 2
              if ((years // 4 == 0) and (years // 100 <> 0)) or (years // 400 == 0)
                daysInMonth := 29
              else
                daysInMonth := 28
          if ++dayOfWeek > 7
            dayOfWeek := 1
        amHours := mHours // 12
        if amHours == 0
          amHours := 12          
      if displayMode == _ClockDisplay
        Display(_MinutesPlace)
      if displayMode == _ClockDisplay
        Display(_HoursPlace)
    if displayMode == _ClockDisplay
      Display(_SecondsPlace)
            
PUB ComError(comType_, rxIndex_, receivedCharacter_, expected_)  | localIndex, localCharacter
  ' debugLock should be set before calling this method.
  ' nordicLock set if comType is _ComNordic
  'Beep.Bonk
  '' _StartOfHeader _StartOfText (board letter*1)? (_Enquire, _Acknowledgment or _Command) 
  '' [type of E, A or C] [parameters] _CarriageReturn
  Com.str(_Debug, string(13,"Prop communication error #"))
  Com.dec(_Debug, gobalErrorCount++)
  Com.str(_Debug, string(", Index = "))
  Com.dec(_Debug, rxIndex_)
  Com.str(_Debug, string(", Expected = "))
  Com.dec(_Debug, expected_)
  Com.str(_Debug, string(", Received = "))
  Com.dec(_Debug, receivedCharacter_)
  Com.str(_Debug, string(", Remaining Rx:", 13))
  localCharacter := receivedCharacter_
  localIndex := 0
  repeat while localCharacter <> 13 and localCharacter <> -1 and localIndex++ < Header#_LargeBufferSize
    if comType_ == _ComNordic
      localCharacter := nordicRxBuffer[++rxIndex_]
    if localCharacter =< 32
      Com.tx(_Debug, 36)
      Com.hex(_Debug, localCharacter, 2)
    else
      Com.tx(_Debug, localCharacter)
    Com.tx(_Debug, 32)
  Com.tx(_Debug, 13)

PUB TransmitString(pointer) : tries | size, sizeIndex, localIndex, dataBlocks, acknowledgeFlag, attempts, localBufferIndex
  '' Sends data to Nordic for Tx.  Listens for "a" plus setCount to know data was
  '' received successfully.  Uses nordicLock.  debugLock will likely already be set by calling method.
  '' not used yet.  So far board D sends data only over wire (RS-485) and only acknowledges wireless
  '' messages.  It doesn't send wireless messages yet.
  
  size := strsize(pointer)
  sizeIndex := size
  'if sizeIndex > 20
    'sizeIndex := 20
  dataBlocks := (size + 1) / Header#_PayloadSize
  if (dataBlocks * Header#_PayloadSize) =< size
    dataBlocks++
  repeat until not lockset(nordicLock) 
  repeat dataBlocks
    localIndex := 6             '5
    setCount++
    nordicTxBuff[5] := Header#_StartOfHeader
    nordicTxBuff[6] := Header#_StartOfText
    nordicTxBuff[7] := byte[pointer++]
    nordicTxBuff[8] := byte[pointer++]
    nordicTxBuff[9] := setCount
    repeat Header#_PayloadSize
      if sizeIndex > 0
        nordicTxBuff[localIndex++] := byte[pointer++]
      elseif sizeIndex == 0
        if nordicTxBuff[localIndex - 1] <> 13 and nordicTxBuff[localIndex - 2] <> 13
          nordicTxBuff[localIndex++] := 13  'Make sure a 13 to end tx
      else                      ' sizeIndex is negative
        nordicTxBuff[localIndex++] := 0               ' fill extra space with zeras
      sizeIndex--  
    ''*100809*Display.tx(13)
    'repeat localBufferIndex from 0 to 29
      ''*100809*Display.hex(nordicTxBuff[localBufferIndex], 2)
    attempts := 0
    acknowledgeFlag := 0
    repeat
      Nordic.xmit(@nordicTxBuff)
      attempts++
      if attempts < 10
        repeat attempts
          waitcnt(clkfreq/50 + cnt)                     ' ** fine tune this
      else
        waitcnt(clkfreq/5 + cnt)                        ' ** and this                             
      
      if ina[_NordicReadyPin] == 1
        Nordic.recv(@nordicRxBuffer)
        ''*100809*Display.str(string(13, "nordicRxBuffer[0] = "))
        ''*100809*Display.dec(nordicRxBuffer[0])
        ''*100809*Display.tx(",")
        ''*100809*Display.dec(nordicTxBuff[5])
        if (nordicRxBuffer[0] == "a") and (nordicRxBuffer[1] == setCount)
          acknowledgeFlag := 1
        else
          '*100809*Display.str(string("Rx[0]= "))
          '*100809*Display.dec(nordicRxBuffer[0])
          '*100809*Display.tx(13)
          '*100809*Display.str(string("should= "))
          '*100809*Display.dec(setCount)
          '*100809*Display.tx(13)                    
    while ((attempts < Header#_TxAttempts) and (acknowledgeFlag == 0))
    if acknowledgeFlag == 0
      '*100809*Beep.Bonk
      'repeat until not lockset(debugLock)
      Com.str(_Debug, string(13, "tries = "))
      Com.dec(_Debug, attempts)
      Com.tx(_Debug, 13)
      'lockclr(debugLock) 
    else
      '*100809*Beep.BeeDeep
      'repeat until not lockset(debugLock)
      Com.str(_Debug, string(13, "successful tx"))
      'lockclr(debugLock)
  lockclr(nordicLock)
  
PRI ReadNunchuck
  
  repeat until not lockset(i2cLock)                                     
  Nunchuck.scan
  lockclr(i2cLock)
  jx := Nunchuck.joyx
  jy := Nunchuck.joyy
  axRaw := Nunchuck.accx
  ayRaw := Nunchuck.accy
  azRaw := Nunchuck.accz
  bz := Nunchuck.btnz
  bc := Nunchuck.btnc
  previousNunchuckOrientation := nunchuckOrientation
  
  if axRaw > _MidLowThreshold and axRaw < _MidHighThreshold
    if ayRaw > _MidLowThreshold and ayRaw < _MidHighThreshold
      if azRaw > _UpLowThreshold and azRaw < _UpHighThreshold
        nunchuckOrientation := _PositiveZAligned
      elseif azRaw > _DownLowThreshold and azRaw < _DownHighThreshold
        nunchuckOrientation := _NegativeZAligned
      else
        nunchuckOrientation := _NotAligned
    elseif azRaw > _MidLowThreshold and azRaw < _MidHighThreshold
      if ayRaw > _UpLowThreshold and ayRaw < _UpHighThreshold
        nunchuckOrientation := _PositiveYAligned
      elseif ayRaw > _DownLowThreshold and ayRaw < _DownHighThreshold
        nunchuckOrientation := _NegativeYAligned
      else
        nunchuckOrientation := _NotAligned
    else
      nunchuckOrientation := _NotAligned  
  elseif ayRaw > _MidLowThreshold and ayRaw < _MidHighThreshold
    if azRaw > _MidLowThreshold and azRaw < _MidHighThreshold
      if axRaw > _UpLowThreshold and axRaw < _UpHighThreshold
        nunchuckOrientation := _PositiveXAligned
      elseif axRaw > _DownLowThreshold and axRaw < _DownHighThreshold
        nunchuckOrientation := _NegativeXAligned
      else
        nunchuckOrientation := _NotAligned
    else
      nunchuckOrientation := _NotAligned    
  else
    nunchuckOrientation := _NotAligned
  
  {repeat until not lockset(debugLock)
  Com.str(_Debug, string(13, "ReadNunchuck Method "))
  Com.str(_Debug, string(13, "jx = "))
  Com.dec(_Debug, jx)
  Com.str(_Debug, string(", jy = "))
  Com.dec(_Debug, jy)
  Com.str(_Debug, string(", axRaw = "))
  Com.dec(_Debug, axRaw)
  Com.str(_Debug, string(", ayRaw = "))
  Com.dec(_Debug, ayRaw)
  Com.str(_Debug, string(", azRaw = "))
  Com.dec(_Debug, azRaw)
  Com.str(_Debug, string(", bz = "))
  Com.dec(_Debug, bz)
  Com.str(_Debug, string(", bz = "))
  Com.dec(_Debug, bz)
  
  lockclr(debugLock)
  }
PUB WriteTime

  if years < 2000
    result := years + 2000
  else
    result := years  
  if clockState
    Clock.writeTime(seconds, minutes, mHours, day, date, months, result)
    
DAT
                            ' 0    1    2    3    4                   5  
nordicTxBuff  byte $AA, $55, $BB, $CC, Header#_NordicInputDevice, "Kill all humans", 13, 0[14]

nordicConfig  byte $C8  ' Data2 width (bits) excluding addr & crc (25 bytes)
              byte $C8  ' Data1 width (bits) excluding addr & crc (25 bytes)
              byte $AA  ' Channel #2 - Addr Byte 1 (MSB)
              byte $55  '            - Addr Byte 2
              byte $BB  '            - Addr Byte 3
              byte $CC  '            - Addr Byte 4
              byte Header#_NordicD
              byte $AA  ' Channel #1 - Addr Byte 1 (MSB) addres this TRF24G responds to
              byte $55  '            - Addr Byte 2
              byte $BB  '            - Addr Byte 3
              byte $CC  '            - Addr Byte 4
              byte Header#_NordicD
              byte $A3  ' 7-2:address width(40), 1:CRC Mode(16), 0:CRC enable(on)
              byte $6F  ' 7:Dual Ch mode(off), 6:ShockBurst mode(on), 5:1m/250k bps(1mbps), 4-2:xtal sel(16Mhz), 1-0:rf Power(hi)
              byte $05  ' 7-1:RF channel(2), 0:RX enable(on=Rx mode)

ledLeft       byte 11[6], 10[6], 9[6], 8[6], 7[6], 6[6]
 
ledRight      byte 18[6], 19[6], 20[6], 21[6], 22[6], 23[6]

ledFront      byte 12, 13, 14, 15, 16, 17, 12, 13, 14, 15, 16, 17, 12, 13, 14, 15, 16, 17
              byte 12, 13, 14, 15, 16, 17, 12, 13, 14, 15, 16, 17, 12, 13, 14, 15, 16, 17 
  
ledA          byte 0, 1, 2, 3, 4, 5, 0, 1, 2, 3, 4, 5, 0, 1, 2, 3, 4, 5
              byte 0, 1, 2, 3, 4, 5, 0, 1, 2, 3, 4, 5, 0, 1, 2, 3, 4, 5

ledC          byte 5, 0, 1, 2, 3, 4, 4, 5, 0, 1, 2, 3, 3, 4, 5, 0, 1, 2  
              byte 2, 3, 4, 5, 0, 1, 1, 2, 3, 4, 5, 0, 0, 1, 2, 3, 4, 5
                   